<template>
    <div class="modal is-active">
        <form action="#" @submit.prevent="submitForm">
            <div class="modal-background"></div>
            <div class="modal-card">
                <header class="modal-card-head">
                    <p class="modal-card-title">{{ $t('modal.suggest.title') }}</p>
                    <button class="delete" aria-label="close" @click="closeModal"></button>
                </header>
                <section class="modal-card-body" v-if="!submitted">
                    <h5 class="title is-5">{{ $t('modal.suggest.subtitle') }}</h5>
                    <div class="field is-horizontal">
                        <div class="field-label is-normal">
                            <label for="title" class="label">{{ $t('modal.suggest.fields.title.label') }}</label>
                        </div>
                        <div class="field-body"><div class="field"><div class="control">
                            <input type="text" name="title" id="title" class="input" required
                                   :placeholder="$t('modal.suggest.fields.title.placeholder')" autocomplete="off" v-model="title">
                        </div></div></div>
                    </div>
                    <div class="field is-horizontal">
                        <div class="field-label is-normal">
                            <label for="series" class="label">{{ $t('modal.suggest.fields.series.label') }}</label>
                        </div>
                        <div class="field-body"><div class="field"><div class="control">
                            <input type="text" name="series" id="series" class="input" required
                                   :placeholder="$t('modal.suggest.fields.series.placeholder')" autocomplete="off" v-model="series">
                        </div></div></div>
                    </div>
                    <div class="field is-horizontal">
                        <div class="field-label is-normal">
                            <label for="type" class="label">{{ $t('modal.suggest.fields.type.label') }}</label>
                        </div>
                        <div class="field-body"><div class="control"><div class="select">
                            <select name="type" id="type" autocomplete="off" v-model="type">
                                <option value="OP" selected>{{ $t('modal.suggest.fields.type.select.op') }}</option>
                                <option value="CS">{{ $t('modal.suggest.fields.type.select.cs') }}</option>
                                <option value="IS">{{ $t('modal.suggest.fields.type.select.is') }}</option>
                                <option value="IN">{{ $t('modal.suggest.fields.type.select.in') }}</option>
                                <option value="ED">{{ $t('modal.suggest.fields.type.select.ed') }}</option>
                                <option value="CM">{{ $t('modal.suggest.fields.type.select.cm') }}</option>
                                <option value="LIVE">{{ $t('modal.suggest.fields.type.select.live') }}</option>
                                <option value="MV">{{ $t('modal.suggest.fields.type.select.mv') }}</option>
                                <option value="AMV">{{ $t('modal.suggest.fields.type.select.amv') }}</option>
                                <option value="PV">{{ $t('modal.suggest.fields.type.select.pv') }}</option>
                                <option value="OT">{{ $t('modal.suggest.fields.type.select.ot') }}</option>
                            </select>
                        </div></div></div>
                    </div>
                    <div class="field is-horizontal">
                        <div class="field-label is-normal">
                            <label for="link" class="label">{{ $t('modal.suggest.fields.link.label') }}</label>
                        </div>
                        <div class="field-body"><div class="field"><div class="control">
                            <input type="url" name="link" id="link" class="input" required
                                   :placeholder="$t('modal.suggest.fields.link.placeholder')" autocomplete="off" v-model="link">
                        </div></div></div>
                    </div>
                    <div class="field is-horizontal">
                        <div class="field-label is-normal">
                            <label for="name" class="label">{{ $t('modal.suggest.fields.name.label') }}</label>
                        </div>
                        <div class="field-body"><div class="field"><div class="control">
                            <input type="text" name="name" id="name" class="input" required
                                   :placeholder="$t('modal.suggest.fields.name.placeholder')" autocomplete="username" v-model="name">
                        </div></div></div>
                    </div>
                </section>
                <section class="modal-card-body" v-else>
                    <h5 class="title is-5">{{ $t('modal.suggest.submitted.subtitle') }}</h5>
                    <i18n path="modal.suggest.submitted.text" tag="p">
                        <template v-slot:here>
                            <a :href="url" target="_blank">{{ $t('modal.suggest.submitted.here') }}</a>
                        </template>
                    </i18n>
                </section>
                <footer class="modal-card-foot">
                    <button class="button is-success" :class="{'is-loading': loading}" v-if="!submitted" type="submit">{{ $t('modal.suggest.submit') }}</button>
                    <button class="button is-success" v-else @click="closeModal">{{ $t('modal.suggest.submitted.close') }}</button>
                </footer>
            </div>
        </form>
    </div>
</template>

<script lang="ts">
    import Vue from 'vue'

    export default Vue.extend({
        data() {
            return {
                title: '',
                series: '',
                type: 'OP',
                link: '',
                name: '',
                submitted: false,
                loading: false,
                url: ''
            }
        },

        methods: {
            submitForm() {
                this.loading = true;
                this.$axios.post(`${process.env.KARA_SERVER}/api/karas/suggest`, {
                    title: this.title,
                    serie: this.series,
                    type: this.type,
                    link: this.link,
                    username: this.name
                }).then(res => {
                    this.submitted = true;
                    this.loading = false;
                    this.url = res.data;
                });
            },
            closeModal() {
                this.$emit('close');
            }
        }
    });
</script>

<style lang="scss">
    .field-body {
        flex-grow: 4;
    }
</style>
